//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
// File Name:port_bit_h.h
//
//  2012/06/13 ishi New
//  2023/03/07 Modify for mega328_i2c_old Taishi
//  2023/05/13 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

// XCb`

#ifdef	cpu64
#define	SW_IN_PORT		(PING)					// input switch port
#define	SW1_ON_BIT		(1 << PING2)			// set switch
#define	SW2_ON_BIT		(1 << PING1)			// select switch
#else
 #ifdef cpu2560
#define	SW_IN_PORT		(PINB)					// input switch port
#define	SW1_ON_BIT		(1 << PINB4)			// set switch (S2)
#define	SW2_ON_BIT		(1 << PINB5)			// select switch (S3)
 #endif
#endif

// XCb`P(SET)̑ԁiWrbgj
#define			SW1_ON_NOW			0x0100		// XCb`PꂽB
#define			SW1_OFF_SHORT		0x0200		// XCb`PꂽBĂԂ͒Z
#define			SW1_OFF_LONG		0x0400		// XCb`PꂽBĂԂ͒
#define			SW1_ON_CONTINUE		0x0800		// XCb`PꑱĂBi莞ԊԊuł̒lxoj
#define			SW1_ON				0x1000		// XCb`PꑱĂBiĂ鎞͂̒loj
#define			SW1_MASK			0x1f00		// XCb`P̐M𒊏o

// XCb`Q(SELECT)̑ԁiWrbgj
#define			SW2_ON_NOW			0x01		// XCb`QꂽB
#define			SW2_OFF_SHORT		0x02		// XCb`QꂽBĂԂ͒Z
#define			SW2_OFF_LONG		0x04		// XCb`QꂽBĂԂ͒
#define			SW2_ON_CONTINUE		0x08		// XCb`QꑱĂBi莞ԊԊuł̒lxoj
#define			SW2_ON				0x10		// XCb`QꑱĂBiĂ鎞͂̒loj
#define			SW2_MASK			0x1f		// XCb`Q̐M𒊏o

#define			SW_MASK				0x1f1f		// XCb`̐M𒊏o


extern	unsigned char	sw[4];					// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏

#ifdef	cpu64
#define	led_green_off()		PORTG &= ~(1 << PG4)
#define	led_green_on()		PORTG |= (1 << PG4)
extern	void			led_grn_on_off(unsigned char on_off);
#else
 #ifdef cpu2560
#define	led_sp1_off()		PORTG &= ~(1 << PG4)
#define	led_sp1_on()		PORTG |= (1 << PG4)
extern	void			led_sp1_on_off(unsigned char on_off);
extern	void			led_sp2_on_off(unsigned char on_off);
 #endif
#endif

extern	void			led_init(void);
extern	void			led_red_on_off(unsigned char on_off);
extern	void			led_blu_on_off(unsigned char on_off);
extern	void			sw_init(void);
extern	void			get_sw(void);
extern	unsigned short	get_action_sw(void);
extern	void			wait_key_off(void);
extern	void			wait_sw_off(void);

extern	unsigned char	check_s1_sw_on(void);
extern	unsigned char	check_s2_sw_on(void);
