//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:set_rtc_6keta.c
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//  2023/05/19 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"pr_mega64_2560_photo_box_h.h"

#include	"timer_h.h"
#include	"port_bit_h.h"
#include	"disp_clock_data_h.h"
#include	"Rtc_Rx8900_h.h"
#include	"infrared_h.h"
#include	"disp_8x48_dot_h.h"

#include	"set_rtc_6keta_h.h"


//*****************************************
// N킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_year_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ye;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uc;
	unsigned char	wday;
	unsigned char	ucinf;

	ye = gRTC_year;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_YEAR,0);			// NuN\
				disp_8x48_clock_item(I_YEAR,0);		// 8x48_N\
			}else{
				blk_stat = 0;
				disp_clock_item(D_YEAR,1);			// N\
				disp_8x48_clock_item(I_YEAR,1);		// 8x48_N\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_year++;
				if(9 < (gRTC_year & 0x0f)){			// X𒴂
					gRTC_year &= 0xf0;
					gRTC_year += 0x10;
				}
				if(0x99 < gRTC_year){
					gRTC_year = 0;
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_year != ye){				// lύX
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					gRTC_wday = rx8900wday(wday);	// qsb j̃f[^ (0b00000001(j <--> 0b01000000(y))
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_YEAR,1);			// N\
				disp_8x48_clock_item(I_YEAR,1);		// 8x48_N\
				break;
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_year != ye){				// lύX
					gRTC_year = ye;					// ̒lɖ߂
				}
				disp_clock_item(D_YEAR,1);			// N\
				disp_8x48_clock_item(I_YEAR,1);		// 8x48_N\
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}

//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_month_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mo;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uc;
	unsigned char	wday;
	unsigned char	ucinf;

	mo = gRTC_mon;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_MON,0);			// uN\
				disp_8x48_clock_item(I_MON,0);		// 8x48_uN\
			}else{
				blk_stat = 0;
				disp_clock_item(D_MON,1);			// \
				disp_8x48_clock_item(I_MON,1);		// 8x48_\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_mon++;
				if(9 < (gRTC_mon & 0x0f)){			// X𒴂
					gRTC_mon &= 0xf0;
					gRTC_mon += 0x10;
				}
				if(0x12 < gRTC_mon){
					gRTC_mon = 1;
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_mon != mo){					// lύX
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					gRTC_wday = rx8900wday(wday);	// qsb j̃f[^ (0b00000001(j <--> 0b01000000(y))
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_MON,1);			// \
				disp_8x48_clock_item(I_MON,1);		// 8x48_\
				break;
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_mon != mo){					// lύX
					gRTC_mon = mo;					// ̒lɖ߂
				}
				disp_clock_item(D_MON,1);			// \
				disp_8x48_clock_item(I_MON,1);		// 8x48_\
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}

//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_day_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	da;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uru=0;
	unsigned char	syo=0;
	unsigned char	uc;
	unsigned char	wday;
	unsigned char	ucinf;

	if(((((gRTC_year/16)*10)+(gRTC_year%16))/4) == 0){	// 邤N
		uru=1;
	}
	if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
		syo=1;
	}
	da = gRTC_day;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_DAY,0);			// uN\
				disp_8x48_clock_item(I_DAY,0);		// 8x48_uN\
			}else{
				blk_stat = 0;
				disp_clock_item(D_DAY,1);			//  \
				disp_8x48_clock_item(I_DAY,1);		// 8x48_\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_day++;
				if(9 < (gRTC_day & 0x0f)){			// X𒴂
					gRTC_day &= 0xf0;
					gRTC_day += 0x10;
				}
				if(syo == 1){						// ̌
					if(0x30 < gRTC_day){
						gRTC_day = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){					// Q 邤N
						if(0x29 < gRTC_day){
							gRTC_day = 1;
						}
					}else{							// Q N
						if(0x28 < gRTC_day){
							gRTC_day = 1;
						}
					}
				}else{								// ̌
					if(0x31 < gRTC_day){
						gRTC_day = 1;
					}
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_day != da){					// lύXꂽ
					wday = subZeller((2000+((gRTC_year >> 4)*10)+(gRTC_year & 0x0f)), (((gRTC_mon >> 4)*10)+(gRTC_mon & 0x0f)), (((gRTC_day >> 4)*10)+(gRTC_day & 0x0f)) );	// cF[̌
					gRTC_wday = rx8900wday(wday);	// qsb j̃f[^ (0b00000001(j <--> 0b01000000(y))
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_DAY,1);			//  \
				disp_8x48_clock_item(I_DAY,1);		// 8x48_\
				break;								// I
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_day != da){					// lύXꂽ
					gRTC_day = da;					// ɖ߂
				}
				disp_clock_item(D_DAY,1);			//  \
				disp_8x48_clock_item(I_DAY,1);		// 8x48_\
				break;								// I
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_hour_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	ho;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uc;
	unsigned char	ucinf;

	ho = gRTC_hou;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_HOUR,0);			// uN\
				disp_8x48_clock_item(I_HOUR,0);		// 8x48_uN\
			}else{
				blk_stat = 0;
				disp_clock_item(D_HOUR,1);			// \
				disp_8x48_clock_item(I_HOUR,1);		// 8x48_\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_hou++;
				if(9 < (gRTC_hou & 0x0f)){			// X𒴂
					gRTC_hou &= 0xf0;
					gRTC_hou += 0x10;
				}
				if(0x23 < gRTC_hou){
					gRTC_hou = 0;
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_hou != ho){					// lύX
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_HOUR,1);			// \
				disp_8x48_clock_item(I_HOUR,1);		// 8x48_\
				break;
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_hou != ho){					// lύX
					gRTC_hou = ho;					// ̒lɖ߂
				}
				disp_clock_item(D_HOUR,1);			// \
				disp_8x48_clock_item(I_HOUR,1);		// 8x48_\
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}

//*****************************************
// 킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_minute_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	mi;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uc;
	unsigned char	ucinf;

	mi = gRTC_min;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_MIN,0);			// uN\
				disp_8x48_clock_item(I_MIN,0);		// 8x48_uN\
			}else{
				blk_stat = 0;
				disp_clock_item(D_MIN,1);			// \
				disp_8x48_clock_item(I_MIN,1);		// 8x48_\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_min++;
				if(9 < (gRTC_min & 0x0f)){			// X𒴂
					gRTC_min &= 0xf0;
					gRTC_min += 0x10;
				}
				if(0x59 < gRTC_min){
					gRTC_min = 0;
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_min != mi){					// lύX
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_MIN,1);			// \
				disp_8x48_clock_item(I_MIN,1);		// 8x48_\
				break;
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_min != mi){					// lύX
					gRTC_min = mi;					// ̒lɖ߂
				}
				disp_clock_item(D_MIN,1);			// \
				disp_8x48_clock_item(I_MIN,1);		// 8x48_\
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// b킹
// ߂l@OFɂqsbɃANZXł
// @@@@PFɂqsbɃANZXłȂ
// @OFԑ얳
//*****************************************
static	unsigned char	proc_set_sec_6keta(void)
{
	unsigned char	blk_stat=0;
	unsigned char	se;
	unsigned short	us;
	unsigned char	r=0;
	unsigned char	uc;
	unsigned char	ucinf;

	se = gRTC_sec;

	tim_10ms_blink = 0;								// _
	while(1){
		us = get_action_sw();						// XCb`Ԃ
		us &= SW_MASK;								// XCb`ɂ
		ucinf = get_infrared_data();				// ԊORfqf[^
		if(us == 0){								// XCb`ĂȂ
			us = trans_if_to_sw(ucinf);				// ԊORf[^XCb`f[^ɕϊ
		}

		if(tim_10ms_blink == 0){					// _Ń^C~O̎
			tim_10ms_blink = 50;
			if((blk_stat==0)&&((us & SW2_ON) == 0)){	// ꂢȂ ł̎(select switch)
				blk_stat = 1;
				disp_clock_item(D_SEC,0);			// buN\
				disp_8x48_clock_item(I_SEC,0);		// 8x48_buN\
			}else{
				blk_stat = 0;
				disp_clock_item(D_SEC,1);			// b\
				disp_8x48_clock_item(I_SEC,1);		// 8x48_b\
			}
		}

		if(us != 0){								// ANVL鎞
			proc_no_key_timeup(1);					// L[͂L
			if(((us & SW2_ON_CONTINUE) != 0)||((us & SW2_ON_NOW) != 0)){	// ꂽA͉ꑱ(select switch)
				gRTC_sec++;
				if(9 < (gRTC_sec & 0x0f)){			// X𒴂
					gRTC_sec &= 0xf0;
					gRTC_sec += 0x10;
				}
				if(0x59 < gRTC_sec){
					gRTC_sec = 0;
				}
			}else if((us & SW1_OFF_LONG) != 0){		// ꎞ(set switch)
				if(gRTC_min != se){					// lύX
					uc = rtc_write_with_reset();	// RTC Nb 
					if(uc != 0){
						rtc_error();				// qsbG[
						r = 1;
					}
				}
				disp_clock_item(D_SEC,1);			// b\
				disp_8x48_clock_item(I_SEC,1);		// 8x48_b\
				break;
			}else if((us & SW1_OFF_SHORT) != 0){	// Zꎞ(set switch)
				if(gRTC_min != se){					// lύX
					gRTC_min = se;					// ̒lɖ߂
				}
				disp_clock_item(D_SEC,1);			// b\
				disp_8x48_clock_item(I_SEC,1);		// 8x48_b\
				break;
			}
		}

		if (proc_no_key_timeup(0) == 0xff){			// ԃL[͂
			r = 0xff;
			break;
		}
	}

	return(r);
}
//*****************************************
// Uv킹
//*****************************************
void	proc_set_rtc_6keta(void)
{
	unsigned char	r=0;

	gDisp_clock_mode = SYMD;						// ݒN
	clear_8x48_G();									// clear 8x48 All LED(6char)
	disp_8x48_clock_const();						// v̌Œ\
	disp_clock_data(1);								// vf[^̕\i1=Sĕ\j

	r = proc_set_year_6keta();						// N킹
	if(r == 0){
		r = proc_set_month_6keta();					// 킹
		if(r == 0){
			r = proc_set_day_6keta();				// 킹
			if(r == 0){
				gDisp_clock_mode = SHMS;			// ݒ莞b
				clear_8x48_G();						// clear 8x48 All LED(6char)
				disp_8x48_clock_const();			// v̌Œ\
				disp_clock_data(1);					// vf[^̕\i1=Sĕ\j
				r = proc_set_hour_6keta();			// 킹
				if(r == 0){
					r = proc_set_minute_6keta();	// 킹
					if(r == 0){
						r = proc_set_sec_6keta();	// b킹
					}
				}
			}
		}
	}
}

