//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
//
// File Name:uart_h.h
//
//  2020/09/01 New TAB4 Taishi
//  2022/10/10 add day_of_week Display Taishi
//  2023/02/01 Modify for pr_mega328_8x8dot_clock Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

#define	BIT_RATE600			600								// rbg|g:600
#define	BIT_RATE1200		1200							// rbg|g:1200
#define	BIT_RATE2400		2400							// rbg|g:2400
#define	BIT_RATE4800		4800							// rbg|g:4800
#define	BIT_RATE9600		9600							// rbg|g:9600


// t`qsP̐ݒl

// aor
#define	BPS_600			(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE600) - 1)	// taqqO̒l(600)
#define	BPS_1200		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE1200) - 1)	// taqqO̒l(1200)
#define	BPS_2400		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE2400) - 1)	// taqqO̒l(2400)
#define	BPS_4800		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE4800) - 1)	// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)(((long)CPU_CLOCK/(long)16/(long)BIT_RATE9600) - 1)	// taqqO̒l(9600)


// peB
#define	V_PARITY_NON	((0 << UPM11) | (0 << UPM10))									// peB
#define	V_PARITY_EVN	((1 << UPM11) | (0 << UPM10))									// peB
#define	V_PARITY_ODD	((1 << UPM11) | (1 << UPM10))									// peB

// f[^
#define	V_DATA_8		((0 << UCSZ12) | (1 << UCSZ11) | (1 << UCSZ10))					// Wrbgf[^
#define	V_DATA_7		((0 << UCSZ12) | (1 << UCSZ11) | (0 << UCSZ10))					// Vrbgf[^

// tbrqP`̒l
#define	V_UCSR1A		(0 << U2X0)														// tbrqP`̒l: W

// tbrqPa̒l
//#define	V_UCSR1B		(1 << TXEN0)												// tbrqPa̒l: M
//#define	V_UCSR1B		((1 << RXEN0) | (1 << RXCIE0) | (1 << TXEN0))					// tbrqPa̒l: MAM荞݉AM
#define	V_UCSR1B		((1 << RXEN0) | (1 << RXCIE0))									// tbrqPa̒l: MAM荞݉
#define	V_UCSR1B_RXEN	(1 << RXEN0)													// tbrqPa̒l: M̂

extern	unsigned short	gBPS_600;

extern	void			uart1_init(void);
extern	void			uart1_close(void);
extern	void			uart1_change_bps(unsigned short us);
extern	void			uart1_pause(void);
extern	void			uart1_restart(void);


extern	void			uart1_tx_one(unsigned char uc);
extern	void			uart1_tx_str(char *str);
extern	void			uart1_tx_str_crlf(char *str);


extern	unsigned char	Get_rxd(unsigned char *uc);

